import { Event } from "@canvas-js/gossiplog/protocols/events";
import { AbstractGossipLog } from "../AbstractGossipLog.js";
export declare const factory: import("@libp2p/interface").StreamMuxerFactory;
export declare class NetworkClient<Payload> {
    readonly gossipLog: AbstractGossipLog<Payload>;
    readonly addr: string;
    log: import("@libp2p/logger").Logger;
    pushProtocol: string;
    syncProtocol: string;
    muxer: import("@libp2p/interface").StreamMuxer;
    duplex: import("it-ws/duplex").DuplexWebSocket;
    sourceURL: string;
    eventSource: import("it-pushable").Pushable<Event, void, unknown>;
    constructor(gossipLog: AbstractGossipLog<Payload>, addr: string);
    private newStream;
    close(): Promise<void>;
    isConnected(): boolean;
    private push;
    private readonly handleMessage;
    private readonly handleProtocolStream;
    private eventSink;
    private handleInsertEvent;
    private handleUpdateEvent;
    private sync;
}
