import http from "node:http";
import { StreamMuxer } from "@libp2p/interface";
import { WebSocket } from "ws";
import { Event } from "@canvas-js/gossiplog/protocols/events";
import { AbstractGossipLog } from "../AbstractGossipLog.js";
export declare const factory: import("@libp2p/interface").StreamMuxerFactory;
export declare class NetworkServer<Payload> {
    readonly gossipLog: AbstractGossipLog<Payload>;
    readonly connections: Map<string, Connection<Payload>>;
    constructor(gossipLog: AbstractGossipLog<Payload>);
    close(): void;
    handleConnection: (socket: WebSocket, req: http.IncomingMessage) => void;
}
declare class Connection<Payload> {
    readonly gossipLog: AbstractGossipLog<Payload>;
    readonly socket: WebSocket;
    readonly id: string;
    readonly log: import("@libp2p/logger").Logger;
    readonly muxer: StreamMuxer;
    readonly eventSource: import("it-pushable").Pushable<Event, void, unknown>;
    readonly pushProtocol: string;
    readonly syncProtocol: string;
    readonly sourceURL: string;
    constructor(gossipLog: AbstractGossipLog<Payload>, socket: WebSocket, req: http.IncomingMessage);
    close(): void;
    isConnected(): boolean;
    private newStream;
    private readonly handleSync;
    private readonly handleMessage;
    private readonly handleProtocolStream;
    private readonly eventSink;
    private push;
    private handleInsertEvent;
    private handleUpdateEvent;
    private sync;
}
export {};
